'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = merge;

var _has = require('lodash/has');

var _has2 = _interopRequireDefault(_has);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _isPlainObject = require('lodash/isPlainObject');

var _isPlainObject2 = _interopRequireDefault(_isPlainObject);

var _isSchema = require('./isSchema');

var _isSchema2 = _interopRequireDefault(_isSchema);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable no-param-reassign */
function merge(target, source) {
  Object.keys(source).forEach(function (key) {
    if (!(0, _has2.default)(source, key)) {
      return;
    }

    var targetVal = target[key];
    var sourceVal = source[key];

    if (sourceVal === undefined) {
      return;
    }

    if ((0, _isSchema2.default)(sourceVal)) {
      target[key] = (0, _isSchema2.default)(targetVal) ? targetVal.concat(sourceVal) : sourceVal;
    } else if ((0, _isPlainObject2.default)(sourceVal)) {
      target[key] = (0, _isPlainObject2.default)(targetVal) ? merge(targetVal, sourceVal) : sourceVal;
    } else if ((0, _isArray2.default)(sourceVal)) {
      target[key] = (0, _isArray2.default)(targetVal) ? targetVal.concat(sourceVal) : sourceVal;
    } else {
      target[key] = source[key];
    }
  });

  return target;
}